#!/usr/bin/perl
# indexsoft intuitive mailer
# http://www.indexsoft.com

$|++;
&ReadArgv();

if ($FORK)
{
	$pid = fork();
	if (!defined $pid) { print "can not fork: $!.\n"; exit; }
	elsif ($pid) { exit; } #forked successfully. PID: $pid
}

if ($QUIET) { close STDIN; close STDOUT; open(STDERR, ">&STDOUT"); }

$ENV{'WINDIR'}?($DirSeparator = '\\'):($DirSeparator = '/');
$imlpath = $0; $imlpath =~ s/(delivery.cgi|delive~1.cgi)$//gi;
chop $imlpath; $imlpath = '.' if !$imlpath;
push (@INC, $imlpath); push (@INC, "$imlpath/modules");
require "intuitive.pm";

eval('use DBI;'); die("$@\n") if $@;
$SIG{__WARN__} = sub { print "$_[0]\n"; };
$MLDBH = DBI->connect("DBI:mysql:database=$mySQLDBName;host=$mySQLHost",$mySQLUser,$mySQLPassword);
$sth = $MLDBH->prepare("select pname, pvalue from _iml_tune");
$sth -> execute();
${$pname} = $pvalue while (($pname, $pvalue) = $sth->fetchrow_array());

if (-e $PIDFile)
{
	unless (open(PIDFILE,$PIDFile)) { die("can not open PID file ($PIDFile).\n") }
	$pid = <PIDFILE>; close PIDFILE;
	if ($oldpid > 1 && kill(0,$oldpid)) { die("process with PID $pid is already running.\n") }
	else { print "process with PID $pid is long dead.\n" }
}
open (PID, ">$PIDFile") or die("can not create PID file ($PIDFile).\n"); print PID $$; close(PID);

eval('use SendMail;'); die("$@\n") if $@;
$sm = new SendMail($SMTP, $SMTPPort);
$sm->setDebug($sm->OFF);

if ($POP3Auth)
{
	eval('use Mail::POP3Client;'); die("$@\n") if $@;
	($pop3login,$pop3password) = split(/:/, $POP3Auth);
	$pop = new Mail::POP3Client(HOST=>"$SMTP", AUTH_MODE=>"PASS", DEBUG=>'0');
	$pop->User("$pop3login");
	$pop->Pass("$pop3password");
	$pop->Connect();
	$pop->Message() =~ /^\+OK/i || die('POP auth: '.$pop->Message()."\n");
	$pop->Close();
}

$statement = "select did, dname, dispatch, DATE_FORMAT(NOW(),'%a, %d %b %Y %T ".&UTC()."') from _iml_dispatches where did in ($DID) and dstart <= NOW()";
$statement = "select did, dname, dispatch, DATE_FORMAT(NOW(),'%a, %d %b %Y %T ".&UTC()."') from _iml_dispatches where dstart <= NOW()" if !$DID;
$sth = $MLDBH->prepare($statement);
$sth -> execute();
$dispatches = $sth->rows();
print "started at ",scalar localtime,". ($dispatches dispatches for delivery)\n---\n" if $dispatches;
while(($did, $dname, $dispatch, $datenow) = $sth->fetchrow_array())
{
	print "start dispatch (ID:$did) $dname\n";
	foreach $line(split(/\255/, $dispatch)) { ($param, $value) = split(/\254/, $line); ${$param} = $value; }
	$BODY =~ s/\n/\r\n/g;
	$MID =~ s/\0/,/g;
	# select users from external DB
	if ($QUERY)
	{
		$sth2 = $MLDBH->prepare("select qdbi, qstatement from _iml_queries where qid=$QUERY");
		$sth2 -> execute();
		($QDBI, $QSTATEMENT) = $sth2->fetchrow_array();
		eval('$EXTDBH = DBI->connect('.$QDBI.')');
		print "$@\n" if $@;
		$sth2 = $EXTDBH->prepare($QSTATEMENT);
	}
	# select users of mlists
	elsif (!$STATEMENT)
	{
		$STATEMENT = "select distinct uname, uemail from _iml_users, _iml_members where muid = uid and mmid in ($MID) and uact = '1'";
		$sth2 = $MLDBH->prepare($STATEMENT);
	}
	# select users from intuitive DB
	else { $sth2 = $MLDBH->prepare($STATEMENT); }
	$sth2 -> execute();
	$found = $sth2->rows();
	print "send messages to $found subscribers\n";
	while (($uname, $uemail) = $sth2->fetchrow_array())
	{
		my ($BODY, $SUBJECT) = ($BODY, $SUBJECT);
		$BODY =~ s/%name%/$uname/g; $BODY =~ s/%email%/$uemail/g;
		$SUBJECT =~ s/%name%/$uname/g;		$SUBJECT =~ s/%email%/$uemail/g;
		if ($ENCODING and $Convert1 and $Convert2)
		{
			eval ("\$SUBJECT =~ tr/$Convert1/$Convert2/;");
			eval ("\$BODY =~ tr/$Convert1/$Convert2/;");
			eval ("\$FROMEMAIL =~ tr/$Convert1/$Convert2/;");
			eval ("\$uname =~ tr/$Convert1/$Convert2/;");
		}
		$sm->From($FROMEMAIL);		$sm->Subject("$SUBJECT");		$sm->To(qq{"$uname"<$uemail>});
		$sm->setMailHeader('Date', "$datenow"); $sm->setMailHeader('X-Priority', "$PRIORITY");
		$sm->setMailHeader('X-Mailer', 'indexsoft intuitive mailer (http://www.indexsoft.com)');
		$sm->setMailHeader('Return-Path', "<$RETURNPATH>");
		grep($sm->setMailHeader(split(/: */, $_)), split(/\0/, $MAILHEADERS)) if (!$FILES and !$HTML);
		$HTML?($sm->Inline('message.htm', \$BODY)):($sm->setMailBody("$BODY"));
		grep(do{ my ($file) = ($_); $file =~ /^.*\.(.*)$/g; my ($ext) = ($1); (($Inline =~ /$ext(,|$)/i)?($sm->Inline("$file")):($sm->Attach("$file"))) if (-e "$_")}, split(/\0/, $FILES));
		if ($sm->sendMail() != 0) { print "$uemail: ".$sm->{'error'}."\n" }
		$sm->reset();
	}
	$MLDBH -> do("delete from _iml_dispatches where did = $did") if $DEL;
	print "finished (ID:$did)\n---\n";
}
print "stoped at ",scalar localtime,".\n" if $dispatches;
unlink $PIDFile;

#########################
sub ReadArgv
{
	($DID, $DEL, $QUIET) = ();
	my ($line) = ();
	foreach $line(@ARGV)
	{
		# --d=1(2...)
		if ($line =~ '^--d=(\d+)$') { $DID?($DID .= ",$1"):($DID = $1); }
		# --del
		elsif ($line =~ '^--del$') { $DEL = 1; }
		# --mail
		elsif ($line =~ '^--quiet$') { $QUIET = 1; }
		# --fork
		elsif ($line =~ '^--fork$') { $FORK = 1; }
	}
}

sub UTC
{
	my @gmt = gmtime(time);
	my @lt = localtime(time);
	$utc = $lt[2] - $gmt[2];
	if ($utc !~ /^-/) { $utc = "+$utc" }
	if (length($utc) == 2)
	{
		$utc =~ s/(\+|-)/$1.'0'/e;
		$utc .= '00';
	}
	else { $utc .= '00' }
	return $utc;
}
